for index = 1, 2 do
	_G["PrimaryProfession".. index]:SetScript("OnMouseUp", function(self)
		if ( IsShiftKeyDown() and ToggleTrackedProfession(self.professionID) ) then
			self.professionName:SetTextColor(0, 0.82, 1);
			PlaySound("igMainMenuOptionCheckBoxOn");
		elseif ( IsShiftKeyDown() ) then
			self.professionName:SetTextColor(1, 0.82, 0);
			PlaySound("igMainMenuOptionCheckBoxOff");
		end
	end);

	_G["PrimaryProfession".. index]:SetScript("OnShow", function(self)
		if ( IsTrackedProfession(self.professionID) ) then
			self.professionName:SetTextColor(0, 0.82, 1);
		else
			self.professionName:SetTextColor(1, 0.82, 0);
		end
	end);
end

for index = 1, 4 do
	_G["SecondaryProfession".. index]:SetScript("OnMouseUp", function(self)
		if ( IsShiftKeyDown() and ToggleTrackedProfession(self.professionID) ) then
			self.professionName:SetTextColor(0, 0.82, 1);
			PlaySound("igMainMenuOptionCheckBoxOn");
		elseif ( IsShiftKeyDown() ) then
			self.professionName:SetTextColor(1, 0.82, 0);
			PlaySound("igMainMenuOptionCheckBoxOff");
		end
	end);

	_G["SecondaryProfession".. index]:SetScript("OnShow", function(self)
		if ( IsTrackedProfession(self.professionID) ) then
			self.professionName:SetTextColor(0, 0.82, 1);
		else
			self.professionName:SetTextColor(1, 0.82, 0);
		end
	end);
end

hooksecurefunc("FormatProfession", function(frame, index)
	frame.professionID = index;
end);

function AddTrackedProfession(professionID)
	if ( professionID ) then
		table.insert(trackedProfession, professionID);
	end
end

function IsTrackedProfession(professionID)
	if ( professionID ) then
		for key, value in pairs(trackedProfession) do
			if ( value == professionID ) then
				return true;
			end
		end
	end
end

function RemoveTrackedProfession(professionID)
	if ( professionID ) then
		for key, value in pairs(trackedProfession) do
			if ( value == professionID ) then
				trackedCooldown[professionID] = nil;
				trackedProfession[key] = nil;
			end
		end
	end
end

function ToggleTrackedProfession(professionID)
	if ( not IsTrackedProfession(professionID) ) then
		AddTrackedProfession(professionID);
		ObjectiveTracker_Update(OBJECTIVE_TRACKER_UPDATE_PROFESSION_ADDED);
		return true;
	else
		RemoveTrackedProfession(professionID);
		ObjectiveTracker_Update(OBJECTIVE_TRACKER_UPDATE_PROFESSION);
		return false;
	end
end
